## rkcommon 1.13.0

=== CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

## Global CMake options ##

if (RKCOMMON_TASKING_SYSTEM STREQUAL "OpenMP")
  cmake_minimum_required(VERSION 3.9) # NOTE(jda): rely on OpenMP targets
else()
  cmake_minimum_required(VERSION 3.1)
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CMAKE_DISABLE_SOURCE_CHANGES ON)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

## Establish project ##

project(rkcommon VERSION 1.13.0 LANGUAGES CXX)

include(GNUInstallDirs)

configure_file(
  ${PROJECT_SOURCE_DIR}/rkcommon/version.h.in
  ${PROJECT_BINARY_DIR}/rkcommon/version.h
  @ONLY
)
set(RKCOMMON_RESOURCE ${PROJECT_SOURCE_DIR}/rkcommon/rkcommon.rc)

## Add rkcommon specific macros ##

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(rkcommon_macros)

rkcommon_configure_build_type()
rkcommon_configure_compiler()
rkcommon_configure_tasking_system()
rkcommon_create_tasking_target(FALSE)

## Build options and specific configuration ##

option(BUILD_SHARED_LIBS "Build rkcommon as a shared library" ON)
option(RKCOMMON_ADDRSAN "Build rkcommon with dlclose disabled for addrsan" OFF)
option(RKCOMMON_NO_SIMD "Build rkcommon not using SIMD instructions" OFF)

set(CMAKE_SKIP_INSTALL_RPATH OFF)
if (APPLE)
  set(CMAKE_MACOSX_RPATH ON)
  set(CMAKE_INSTALL_RPATH "@loader_path/")
else()
  set(CMAKE_INSTALL_RPATH "\$ORIGIN")
endif()

include(CTest)

if (BUILD_TESTING)
  enable_testing()
endif()

if (WIN32)
  option(INSTALL_DEPS "Install rkcommon DLL dependencies" ON)
else()
  set(INSTALL_DEPS OFF)
endif()

if (INSTALL_DEPS)
  include(rkcommon_redist_deps)
endif()

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

## Build library and tests ##

add_subdirectory(rkcommon)

if (BUILD_TESTING)
  add_subdirectory(tests)
endif()

## Configure CMake find_package() config files ##

include(CMakePackageConfigHelpers)

configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in"
  "${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake"
INSTALL_DESTINATION
  ${CMAKE_INSTALL_LIBDIR}/cmake/rkcommon-${PROJECT_VERSION}
)

write_basic_package_version_file(
    "${PROJECT_NAME}ConfigVersion.cmake"
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

install(FILES
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}Config.cmake
  ${PROJECT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
  cmake/FindTBB.cmake
  cmake/rkcommon_macros.cmake
DESTINATION
  ${CMAKE_INSTALL_LIBDIR}/cmake/rkcommon-${PROJECT_VERSION}
)

# Must be last
include(CPack)

=== rkcommon/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

if (RKCOMMON_TASKING_INTERNAL)
  set(EXTRA_TASKING_SOURCES
    tasking/detail/enkiTS/TaskScheduler.cpp
    tasking/detail/TaskSys.cpp
  )
endif()

add_library(${PROJECT_NAME}
  ${RKCOMMON_RESOURCE}

  common.cpp

  memory/malloc.cpp

  networking/DataStreaming.cpp
  networking/Fabric.cpp

  os/FileName.cpp
  os/library.cpp

  tasking/detail/tasking_system_init.cpp

  ${EXTRA_TASKING_SOURCES}

  utility/demangle.cpp
  utility/ParameterizedObject.cpp
  utility/PseudoURL.cpp
  utility/TimeStamp.cpp

  xml/XML.cpp

  tracing/Tracing.cpp
)

target_link_libraries(${PROJECT_NAME}
  PUBLIC
    rkcommon_tasking
    ${CMAKE_DL_LIBS}
    $<${RKCOMMON_PLATFORM_WIN}:ws2_32>
)

target_include_directories(${PROJECT_NAME}
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE
    ${CMAKE_CURRENT_LIST_DIR}
)

if (RKCOMMON_ADDRSAN)
  target_compile_definitions(${PROJECT_NAME} PUBLIC -DRKCOMMON_ADDRSAN)
endif()

if (RKCOMMON_NO_SIMD)
  target_compile_definitions(${PROJECT_NAME} PUBLIC -DRKCOMMON_NO_SIMD)
endif()

set_property(TARGET rkcommon PROPERTY POSITION_INDEPENDENT_CODE ON)

## Install library + targets ##################################################

set_target_properties(${PROJECT_NAME}
    PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

install(TARGETS ${PROJECT_NAME}
  EXPORT rkcommon_Exports
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    NAMELINK_SKIP
  # on Windows put the dlls into bin
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  # ... and the import lib into the devel package
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT rkcommon_Exports
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/rkcommon-${PROJECT_VERSION}
  NAMESPACE rkcommon::
)

install(TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    NAMELINK_ONLY
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

## Install headers ############################################################

install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  FILES_MATCHING
  PATTERN *.h
  PATTERN *.inl
  PATTERN *.hpp
  PATTERN *.ih
)

=== debian/changelog ===
rkcommon (1.13.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1039110)

 -- Francois Mazen <mzf@debian.org>  Fri, 13 Oct 2023 22:43:30 +0200

=== debian/control ===
Source: rkcommon
Section: graphics
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Francois Mazen <mzf@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               libtbb-dev
Standards-Version: 4.6.2
Homepage: https://github.com/ospray/rkcommon
Vcs-Browser: https://salsa.debian.org/science-team/rkcommon
Vcs-Git: https://salsa.debian.org/science-team/rkcommon.git
Rules-Requires-Root: no

Package: librkcommon1
Architecture: any-amd64 arm64
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Intel RenderKit common C++/CMake infrastructure
 This project represents a common set of C++ infrastructure and CMake
 utilities used by various components of Intel oneAPI Rendering Toolkit.

Package: librkcommon-dev
Architecture: any-amd64 arm64
Section: libdevel
Depends: librkcommon1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Development files for librkcommon
 This package contains libraries and header files for
 applications that use librkcommon.

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/ospray/rkcommon/tags?per_page=50 \
https://api.github.com/repos/ospray/rkcommon/tarball/refs/tags/v?@ANY_VERSION@

## rkcommon 1.14.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 if (RKCOMMON_TASKING_SYSTEM STREQUAL "OpenMP")
   cmake_minimum_required(VERSION 3.9) # NOTE(jda): rely on OpenMP targets
 else()
-  cmake_minimum_required(VERSION 3.1)
+  cmake_minimum_required(VERSION 3.5)
 endif()
 
 set(CMAKE_CXX_STANDARD 11)
@@ -18,7 +18,7 @@
 
 ## Establish project ##
 
-project(rkcommon VERSION 1.13.0 LANGUAGES CXX)
+project(rkcommon VERSION 1.14.2 LANGUAGES CXX)
 
 include(GNUInstallDirs)
 
@@ -45,6 +45,7 @@
 option(BUILD_SHARED_LIBS "Build rkcommon as a shared library" ON)
 option(RKCOMMON_ADDRSAN "Build rkcommon with dlclose disabled for addrsan" OFF)
 option(RKCOMMON_NO_SIMD "Build rkcommon not using SIMD instructions" OFF)
+option(RKCOMMON_WARN_AS_ERRORS "Treat warnings as errors" OFF)
 
 set(CMAKE_SKIP_INSTALL_RPATH OFF)
 if (APPLE)

=== rkcommon/CMakeLists.txt ===
--- 
+++ 
@@ -51,6 +51,10 @@
     ${CMAKE_CURRENT_LIST_DIR}
 )
 
+if (RKCOMMON_TASKING_INTERNAL)
+  target_compile_definitions(${PROJECT_NAME} PRIVATE -DENKITS_BUILD_DLL)
+endif()
+
 if (RKCOMMON_ADDRSAN)
   target_compile_definitions(${PROJECT_NAME} PUBLIC -DRKCOMMON_ADDRSAN)
 endif()
@@ -59,7 +63,15 @@
   target_compile_definitions(${PROJECT_NAME} PUBLIC -DRKCOMMON_NO_SIMD)
 endif()
 
-set_property(TARGET rkcommon PROPERTY POSITION_INDEPENDENT_CODE ON)
+if (RKCOMMON_WARN_AS_ERRORS)
+  if(MSVC)
+    target_compile_options(${PROJECT_NAME} PRIVATE /WX)
+  else()
+    target_compile_options(${PROJECT_NAME} PRIVATE -Werror)
+  endif()
+endif()
+
+set_property(TARGET ${PROJECT_NAME} PROPERTY POSITION_INDEPENDENT_CODE ON)
 
 ## Install library + targets ##################################################

=== tests/CMakeLists.txt ===
## Copyright 2009 Intel Corporation
## SPDX-License-Identifier: Apache-2.0

add_executable(rkcommon_test_suite
  ${RKCOMMON_RESOURCE}

  catch_main.cpp

  array3D/test_Array3D.cpp
  array3D/test_for_each.cpp

  math/test_AffineSpace.cpp
  math/test_box.cpp
  math/test_constants.cpp
  math/test_LinearSpace.cpp
  math/test_rkmath.cpp
  math/test_Quaternion.cpp
  math/test_range.cpp
  math/test_vec.cpp

  memory/test_DeletedUniquePtr.cpp
  memory/test_malloc.cpp
  memory/test_RefCount.cpp

  os/test_FileName.cpp
  os/test_library.cpp

  containers/test_AlignedVector.cpp
  containers/test_FlatMap.cpp
  containers/test_TransactionalBuffer.cpp

  tasking/test_async.cpp
  tasking/test_AsyncLoop.cpp
  tasking/test_AsyncTask.cpp
  tasking/test_parallel_for.cpp
  tasking/test_parallel_foreach.cpp
  tasking/test_schedule.cpp

  traits/test_traits.cpp

  utility/test_AbstractArray.cpp
  utility/test_Any.cpp
  utility/test_ArgumentList.cpp
  utility/test_ArrayView.cpp
  utility/test_CodeTimer.cpp
  utility/test_DataView.cpp
  utility/test_demangle.cpp
  utility/test_DoubleBufferedValue.cpp
  utility/test_getEnvVar.cpp
  utility/test_multidim_index_sequence.cpp
  utility/test_Observers.cpp
  utility/test_OnScopeExit.cpp
  utility/test_Optional.cpp
  utility/test_OwnedArray.cpp
  utility/test_ParameterizedObject.cpp
  utility/test_PseudoURL.cpp
  utility/test_random.cpp
  utility/test_SaveImage.cpp
  utility/test_StringManip.cpp
  utility/test_TimeStamp.cpp
  utility/test_TransactionalValue.cpp
)

target_link_libraries(rkcommon_test_suite PRIVATE rkcommon)

add_test(NAME ArgumentList          COMMAND rkcommon_test_suite "[ArgumentList]")
add_test(NAME ArrayView             COMMAND rkcommon_test_suite "[ArrayView]")
add_test(NAME OnScopeExit           COMMAND rkcommon_test_suite "[OnScopeExit]")
add_test(NAME Optional              COMMAND rkcommon_test_suite "[Optional]")
add_test(NAME FlatMap               COMMAND rkcommon_test_suite "[FlatMap]")
add_test(NAME TransactionalBuffer   COMMAND rkcommon_test_suite "[TransactionalBuffer]")
add_test(NAME StringManip           COMMAND rkcommon_test_suite "[StringManip]")
add_test(NAME random                COMMAND rkcommon_test_suite "[random]")
if(NOT WIN32) # Tests which are broken on Windows with unknown fixes (for now)
  add_test(NAME Any                 COMMAND rkcommon_test_suite "[Any]")
  add_test(NAME AlignedVector       COMMAND rkcommon_test_suite "[AlignedVector]")
  add_test(NAME Observers           COMMAND rkcommon_test_suite "[Observers]")
  add_test(NAME ParameterizedObject COMMAND rkcommon_test_suite "[ParameterizedObject]")
  add_test(NAME async               COMMAND rkcommon_test_suite "[async]")
  add_test(NAME parallel_for        COMMAND rkcommon_test_suite "[parallel_for]")
  add_test(NAME parallel_foreach    COMMAND rkcommon_test_suite "[parallel_foreach]")
  add_test(NAME schedule            COMMAND rkcommon_test_suite "[schedule]")
endif()

install(TARGETS rkcommon_test_suite
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== debian/changelog ===
rkcommon (1.14.2-1) unstable; urgency=medium

  * New upstream release.
  * Update upstream github URL.
  * Bump standard version. 

 -- Francois Mazen <mzf@debian.org>  Sun, 29 Sep 2024 20:18:56 +0200

=== debian/control ===
--- 
+++ 
@@ -6,8 +6,8 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libtbb-dev
-Standards-Version: 4.6.2
-Homepage: https://github.com/ospray/rkcommon
+Standards-Version: 4.7.0
+Homepage: https://github.com/RenderKit/rkcommon
 Vcs-Browser: https://salsa.debian.org/science-team/rkcommon
 Vcs-Git: https://salsa.debian.org/science-team/rkcommon.git
 Rules-Requires-Root: no

=== debian/rules ===
#!/usr/bin/make -f

#DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Upstream supports SIMD on amd64 and arm64 only.
NO_SIMD=ON
ifeq ($(DEB_BUILD_ARCH), amd64)
NO_SIMD=OFF
else ifeq ($(DEB_BUILD_ARCH), arm64)
NO_SIMD=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_TESTING=ON \
		-DRKCOMMON_NO_SIMD=$(NO_SIMD)

=== debian/tests/control ===
Tests: build-and-run
Depends: librkcommon-dev, build-essential

=== debian/watch ===
version=4
opts="searchmode=plain,\
filenamemangle=s%v?@ANY_VERSION@%@PACKAGE@-$1.tar.xz%" \
https://api.github.com/repos/RenderKit/rkcommon/tags?per_page=50 \
https://api.github.com/repos/RenderKit/rkcommon/tarball/refs/tags/v?@ANY_VERSION@
